module Lib where

import Control.Concurrent.Chan
import Control.Concurrent (threadDelay)
import Control.Monad (forever)


fetcher :: String -> IO Bool
fetcher url = do
  putStrLn $ "fetching " <> url
  threadDelay 1000000
  return $ if url `elem` ["url6", "url2"] then False else True

-- | submit actions to jobChan, worker will run it and put result in
-- resultChan.
worker :: Chan (IO a) -> Chan a -> IO ()
worker jobChan resultChan = forever $ do
  action <- readChan jobChan
  r <- action
  writeChan resultChan r
