module UseTwoChans (downloadAll) where

import Control.Concurrent (forkIO)
import Control.Monad (replicateM, replicateM_)
import Control.Concurrent.Chan

import Lib

downloadAll :: IO Bool
downloadAll = do
  jobChan :: Chan (IO Bool) <- newChan
  resultChan :: Chan Bool <- newChan

  replicateM_ 2 $ forkIO $ worker jobChan resultChan

  let urlBatch1 = ["url1", "url2", "url3"]
  mapM_ (writeChan jobChan . fetcher) urlBatch1
  let urlBatch2 = ["url4", "url5", "url6", "url7", "url8"]
  mapM_ (writeChan jobChan . fetcher) urlBatch2
  let urlBatch3 = ["url9", "url10", "url11", "url12", "url13", "url14"]
  mapM_ (writeChan jobChan . fetcher) urlBatch3

  let expectedResultCount = length $ urlBatch1 <> urlBatch2 <> urlBatch3
  results <- replicateM expectedResultCount (readChan resultChan)
  let failedCount = length (filter (not . id) results)
  putStrLn $ show failedCount <> " failed"
  return $ and results
